@echo off

setlocal

REM
REM  Copyright (C) 2007 Funambol, Inc.  All rights reserved.
REM
REM  Before running this script:
REM  - set the JAVA_HOME
REM  - copy the JDBC driver in the lib directory. It will be automatically loaded.
REM
REM  Set the JMX_PORT variable below to a different value if the one specified is
REM  already in use.
REM

set JMX_PORT=3101

set CURRENT_DIR=%cd%
set SCRIPT_NAME=%~nx0
set OX_LISTENER_HOME=%~dp0..

set BUNDLED_JAVA_HOME=
if not "%BUNDLED_JAVA_HOME%" == "" set JAVA_HOME=%BUNDLED_JAVA_HOME%

if not "%JAVA_HOME%" == "" goto verifyJavaHome
echo ERROR: Please, set JAVA_HOME before running this script.
goto END

:verifyJavaHome
if EXIST "%JAVA_HOME%\bin\java.exe" goto okJavaHome
echo ERROR: Set JAVA_HOME to the path of a valid jre.
goto END

:okJavaHome

REM setting classpath
REM ---------
cd %OX_LISTENER_HOME%\lib
set CLASSPATH=%OX_LISTENER_HOME%\lib
for %%i in (*.jar) do call :append %%i
goto okClasspath
:append
set CLASSPATH=%CLASSPATH%;%OX_LISTENER_HOME%\lib\%*
goto :eof

:okClasspath
cd ..

set JAVA_OPTS=%JAVA_OPTS% -Dfile.encoding=UTF-8
set JAVA_OPTS=%JAVA_OPTS% -Dfunambol.pushlistener.home="%OX_LISTENER_HOME%"
set JAVA_OPTS=%JAVA_OPTS% -Dfunambol.pushlistener.config.bean="com/funambol/oxlistener/OXListenerConfiguration.xml"
set JAVA_OPTS=%JAVA_OPTS% -Djava.library.path="%OX_LISTENER_HOME%\lib\win32"

set JMX_BEAN=com.funambol.oxlistener:type=OXListener

if ""%1"" == ""start""    goto doStart
if ""%1"" == ""status""   goto doStatus
if ""%1"" == ""stop""     goto doStop
if ""%1"" == ""license""  goto doLicense

goto printUsage

:doStart
if ""%2"" == """" (
    set EXEC=start "OX Listener" "%JAVA_HOME%\bin\javaw.exe"
) else (
    if ""%2"" == ""-debug"" (
      if ""%3"" == """" (
          set EXEC="%JAVA_HOME%\bin\java.exe"
      ) else (
          goto printUsage
      )
    ) else (
        goto printUsage
    )
)

set CLASS_NAME=com.funambol.oxlistener.service.OXListener
set JAVA_OPTS=%JAVA_OPTS% -Dcom.sun.management.jmxremote -Dcom.sun.management.jmxremote.port=%JMX_PORT% -Dcom.sun.management.jmxremote.ssl=false -Dcom.sun.management.jmxremote.authenticate=false

rem Uncomment the following line to enable remote debug
rem set JAVA_OPTS=%JAVA_OPTS% -Xdebug -Xrunjdwp:transport=dt_socket,address=7777,server=y,suspend=n

goto CONT1

:doStop
if not ""%2"" == """" (
    goto printUsage
)
set EXEC="%JAVA_HOME%\bin\java.exe"
set CLASS_NAME=com.funambol.pushlistener.service.ManagementTools
set ARGS=%JMX_BEAN% localhost %JMX_PORT% stop
goto CONT1

:doStatus
if not ""%2"" == """" (
    goto printUsage
)
set EXEC="%JAVA_HOME%\bin\java.exe"
set CLASS_NAME=com.funambol.pushlistener.service.ManagementTools
set ARGS=%JMX_BEAN% localhost %JMX_PORT% status
goto CONT1

:doLicense
type "%OX_LISTENER_HOME%"\LICENSE.txt | more
goto END

:printUsage
echo Usage: %SCRIPT_NAME% command
echo command:
echo   start           Start OX Listener
echo   start -debug    Start OX Listener with output console
echo   stop            Stop OX Listener
echo   status          Show OX Listener status
echo   license         Show the license
goto END

:CONT1
echo OX_LISTENER_HOME: "%OX_LISTENER_HOME%"
echo CLASSPATH: "%CLASSPATH%"
echo JAVA_OPTS: %JAVA_OPTS%

%EXEC% %JAVA_OPTS% -classpath "%CLASSPATH%" %CLASS_NAME% %ARGS%

:END
cd %CURRENT_DIR%

endlocal
